<script setup lang="ts">
import { dateZhTW, zhTW } from 'naive-ui'
import { parseColor, theme } from 'unocss/preset-mini'

const ThemeProvider = defineComponent({
  name: 'ThemeProvider',
  setup() {
    const slots = useSlots()

    onMounted(() => {
      const { height } = useWindowSize()

      watch(height, (h) => {
        document.documentElement.style.setProperty('--screen', `${h}px`)
      }, { immediate: true })

      const themeVars = useThemeVars()

      watch(themeVars, (vars) => {
        const config = {
          '--n-primary': 'primaryColor',
          '--n-info': 'infoColor',
          '--n-success': 'successColor',
          '--n-warning': 'warningColor',
          '--n-error': 'errorColor',
        } as const

        Object.entries(config).forEach(([k, v]) => {
          const value = parseColor(`[${vars[v]}]`, theme)?.cssColor?.components.join(' ')

          if (value)
            document.documentElement.style.setProperty(k, value)
        })
      }, { immediate: true })
    })

    return () => {
      if (slots.default)
        return slots.default()
    }
  },
})

onMounted(() => {
  const { colorModePreference } = useNaiveColorMode()

  watchEffect(() => {
    colorModePreference.set(isDark.value ? 'dark' : 'light')
  })
})
</script>

<template>
  <NaiveConfig :locale="zhTW" :date-locale="dateZhTW">
    <NMessageProvider>
      <NNotificationProvider>
        <NDialogProvider>
          <ThemeProvider>
            <slot></slot>
          </ThemeProvider>
        </NDialogProvider>
      </NNotificationProvider>
    </NMessageProvider>
  </NaiveConfig>
</template>
